\ProvidesPackage{wmf-beamer}[2022/09/30]
%PDFLaTeX support for WMF style in Beamer

%%dependencies

%For image inclusion and layout
\RequirePackage{graphicx}
\RequirePackage{tikz}

%Font packages only work with PDFTeX (cf https://bugs.debian.org/1021166 )
\RequirePackage{iftex}
\RequirePDFTeX

%%Colours - https://meta.wikimedia.org/wiki/Brand/colours
\definecolor{wmfred}{RGB}{151,3,2}
\definecolor{wmfpink}{RGB}{230,121,166}
\definecolor{wmforange}{RGB}{238,128,25}
\definecolor{wmfyellow}{RGB}{240,188,0}
\definecolor{wmfpurple}{RGB}{87,72,181}
\definecolor{wmfdarkgreen}{RGB}{48,93,112}
\definecolor{wmfblue}{RGB}{14,101,192}
\definecolor{wmfbrightblue}{RGB}{4,157,255}
\definecolor{wmfbrightyellow}{RGB}{233,231,196}
\definecolor{wmfgreen}{RGB}{48,133,87}
\definecolor{wmfbrightgreen}{RGB}{113,209,179}

%%Fonts
%Fonts - Source Serif Pro for serif, Montserrat for sans-serif, source
%code pro for monospace
\RequirePackage[regular]{sourceserifpro}
\RequirePackage{montserrat}
\RequirePackage{sourcecodepro}
\RequirePackage[T1]{fontenc}

%sans serif for headline/footline and titles
\usefonttheme[stillsansserifsmall,stillsansseriflarge]{serif}
%Bold for titles &c.
\usefonttheme{structurebold}
%Make the title a bit bigger
\setbeamerfont{title}{size=\Huge}

%Make titles et al use same colors as the rest of the slide
%\usecolortheme[rgb={0,0,0}]{structure}
\setbeamercolor*{structure}{parent=normal text}
\setbeamercolor{footline}{parent=normal text}
\setbeamercolor*{palette primary}{parent=normal text}
\setbeamercolor*{palette secondary}{parent=normal text}
\setbeamercolor*{palette tertiary}{parent=normal text}
\setbeamercolor*{palette quaternary}{parent=normal text}
\setbeamercolor{math text}{parent=normal text}
\setbeamercolor{normal text in math text}{parent=math text}
\setbeamercolor{item projected}{parent=item}
\setbeamercolor{description body}{parent=item}
\setbeamercolor*{block body}{fg=green}%{parent=normal text}
\setbeamercolor{block body alerted}{parent=block body}
\setbeamercolor{block body example}{parent=block body}


%%Utility function to tell if foreground colour is currently white
\makeatletter
\edef\whitestring{white}
\newcommand\ifbeamercolorwhite[2]{%
  \ifx\beamer@thc@fg\whitestring
    #1
  \else
    #2
  \fi
}
\makeatother

%%Logo functions
%bottom left, for normal slides
\newcommand{\wmflogo}[1]{
  \begin{tikzpicture}[remember picture,overlay]
    \node [anchor=south west,xshift=0.02\textwidth,yshift=0.01\textheight]
    at (current page.south west) {
      \includegraphics[width=0.05\textwidth]{#1}
    };
  \end{tikzpicture}
}

%top left, for title slide
\newcommand{\wmfwithtext}[1]{
  \begin{tikzpicture}[remember picture,overlay]
    \node [anchor=north west,xshift=0.02\textwidth,yshift=-0.01\textheight]
    at (current page.north west) {
      \includegraphics[width=0.3\textwidth]{#1}
    };
  \end{tikzpicture}
}

%large and central, for the final slide
\newcommand{\wmfcentral}[1]{
  \begin{tikzpicture}[remember picture,overlay]
    \node
    at (current page.center) {
      \includegraphics[width=0.5\textwidth]{#1}
    };
  \end{tikzpicture}
}

%%Normal slide styling

%Turn off navigation symbols
\setbeamertemplate{navigation symbols}{}

%Logo in appropriate colour
\setbeamertemplate{footline}{
  \ifbeamercolorwhite{\wmflogo{logos/Wikimedia-logo_white.pdf}}
                     {\wmflogo{logos/Wikimedia-logo_black.pdf}}
}


%%Title slide style
\setbeamertemplate{title page}{
  {
    \usebeamercolor[fg]{normal text}
    \ifbeamercolorwhite
        {\wmfwithtext{logos/Wikimedia_Foundation_logo_-_horizontal_white.pdf}}
        {\wmfwithtext{logos/Wikimedia_Foundation_logo_-_horizontal.pdf}}
  }

  \begin{tikzpicture}[remember picture,overlay]
    \node at (current page.center) {
    \begin{beamercolorbox}[sep=8pt,center]{title}
      \usebeamerfont{title}\inserttitle\par%
    \end{beamercolorbox}%
    };
  \end{tikzpicture}


  \begin{tikzpicture}[remember picture, overlay]
    \node [align=left,anchor=south west,yshift=1ex] at
    (current page.south west) {
      \usebeamercolor[fg]{normal text}
      \begin{tabular}{l}
      \usebeamerfont{author}\insertauthor \\
      \usebeamerfont{date}\insertdate
    \end{tabular}
    };
  \end{tikzpicture}
}

%% "Chapter" slide style, use with Beamer parts e.g.
%\part[]{Chapter title goes here}
%\begin{frame}[plain]
%  \partpage
%\end{frame}
\setbeamertemplate{part page}{
  {
    \usebeamercolor[fg]{normal text}
    \ifbeamercolorwhite
        {\wmfwithtext{logos/Wikimedia_Foundation_logo_-_horizontal_white.pdf}}
        {\wmfwithtext{logos/Wikimedia_Foundation_logo_-_horizontal.pdf}}
  }
  \begin{columns}[t]
    \usebeamercolor[fg]{normal text}
    \column{0.25\textwidth}
           {\usebeamerfont{title}\insertpartnumber}
     \column{0.75\textwidth}
            {\usebeamerfont{title}\insertpart}
  \end{columns}

  \makeatletter
  \ifx\insertshortpart\@empty%
  \else%
    \begin{tikzpicture}[remember picture, overlay]
    \node [anchor=south west,yshift=0.05\textheight] at
    (current page.245) {
      \usebeamercolor[fg]{normal text}
      \insertshortpart
    };
  \end{tikzpicture}
  \fi%
}

%% Final slide
%This needs its own function, to be used thus:
%\begin{frame}[plain]
%\WMFContactSlide{me@wikimedia.org}
%\end{frame}

\newcommand\WMFContactSlide[1]{

  %Big central logo
  {
    \usebeamercolor[fg]{normal text}
    \ifbeamercolorwhite
        {\wmfcentral{logos/Wikimedia_Foundation_logo_-_horizontal_white.pdf}}
        {\wmfcentral{logos/Wikimedia_Foundation_logo_-_horizontal.pdf}}
  }

  %Contact details bottom right
  \begin{tikzpicture}[remember picture, overlay]
    \node [align=left,anchor=south east,yshift=2ex] at
    (current page.south east) {
      \usebeamercolor[fg]{normal text}
      \begin{tabular}{r}
      \usebeamerfont{author}Contact me \\
      \usebeamerfont{author}#1
    \end{tabular}
    };
  \end{tikzpicture}

}
